package wrapper;

import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Properties;
import java.util.Set;

import javax.crypto.SecretKey;

import policy.HIPAAQuery;
import policy.HIPAAResult;
import policy.ReadHIPAAPolicy;
import security.abemodule.documentencryptiondecryption.DesEncrypter;
import security.abemodule.documentencryptiondecryption.DesEncrypterWrapper;
import security.abemodule.encryption.DocumentEncryptor;
import security.abemodule.utility.HipaaResultFormatter;


// all paths (except for fileEncryptionKeyName and encryptedKeyName) need to be absolute

public class EncryptionModule {
	
	public static String policyStoreFileName = "/Users/frankwang/Desktop/healthcareproj2/IHI/HIPAA_ABE_Encryption/src/policy/HIPAAPolicyJava.ser";
	
	public String desFileEncryptionKeyName;// name of the des key of the file
	public String desFileEncryptionKeyPath;// path of des key
	public String toBeEncryptedFilePath;// path of unencrypted file
	public String encryptedFilePath;// path of encrypted file (encrypted using des key)
	public String abeEncryptedKeyName; //name of abe encrypted key of des key
	public HIPAAQuery q;
	
	public int encrypt(){
		DesEncrypterWrapper wrapper = new DesEncrypterWrapper();
		SecretKey key = wrapper.generateDesKey();
		
		wrapper.saveDesKey(key, desFileEncryptionKeyName);
		DesEncrypter encrypter;
		try {
			encrypter = new DesEncrypter(key);
			encrypter.encrypt(new FileInputStream(toBeEncryptedFilePath), new FileOutputStream(encryptedFilePath));
		}
		catch (Exception e) {
			e.printStackTrace();
		}
		
		HashMap<String, Set<HIPAAResult>> policy = null;
		try {
			policy = (HashMap<String, Set<HIPAAResult>>)ReadHIPAAPolicy.unserializeObject(policyStoreFileName);
		} catch (ClassNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		System.out.println("query hash = " + q.toString());
		Set<HIPAAResult> possibleResults = policy.get(q.toString());			
		System.out.println(possibleResults);
		HipaaResultFormatter h = new HipaaResultFormatter(possibleResults);
		DocumentEncryptor documentencryptor = new DocumentEncryptor("/Users/frankwang/Desktop/fenc-0.2.0/tools/", desFileEncryptionKeyName,desFileEncryptionKeyPath);	
		documentencryptor.gotokeydir();
		ArrayList<String> attributeList = h.stringFormat();
		int count = documentencryptor.encryptDocumentUsingAttributeList(attributeList, abeEncryptedKeyName);
		return count;
	}
}
