package security.abemodule.documentencryptiondecryption;

import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.security.NoSuchAlgorithmException;

import javax.crypto.KeyGenerator;
import javax.crypto.SecretKey;
import javax.crypto.spec.SecretKeySpec;

public class DesEncrypterWrapper{
	
	public SecretKey generateDesKey(){
		SecretKey key = null;
		try {
			key = KeyGenerator.getInstance("DES").generateKey();
		} catch (NoSuchAlgorithmException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return key;
	}
	
	public void saveDesKey(SecretKey key, String keyFileName){
		byte[] keypreface = new String("Key-" + new String(key.getEncoded())).getBytes();
		System.out.println(new String(keypreface));
		FileOutputStream fos;
		try {
			fos = new FileOutputStream(keyFileName);
			fos.write(keypreface);
			fos.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}		
	}
	
	public SecretKey retrieveDesKey(String keyFileName){
		FileInputStream fis = null;
		int keySize=0;
		try {
			fis = new FileInputStream(keyFileName);
			keySize = fis.available();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		byte[] retrieved = new byte[keySize];
		try {
			fis.read(retrieved);
			fis.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		String removeHeader = new String(retrieved);
		System.out.println("before:"+removeHeader);
		byte[] finalRetrieved = removeHeader.substring(removeHeader.indexOf("-")+1).getBytes();
		System.out.println("after:"+ new String(finalRetrieved));
		SecretKey key = new SecretKeySpec(finalRetrieved,"DES");
		return key;
		
	}
	public static void main(String[] argv) throws Exception {
		DesEncrypterWrapper wrapper = new DesEncrypterWrapper();
		SecretKey key = wrapper.generateDesKey();
		String keyFileName = "myKey.key";
		wrapper.saveDesKey(key, keyFileName);
		DesEncrypter encrypter = new DesEncrypter(key);
		encrypter.encrypt(new FileInputStream("resources/cleartext.txt"), new FileOutputStream("resources/ciphertext"));
		SecretKey newKey = wrapper.retrieveDesKey(keyFileName);
		DesEncrypter newEncrypter = new DesEncrypter(newKey);
		newEncrypter.decrypt(new FileInputStream("resources/ciphertext"), new FileOutputStream("resources/cleartext2.txt"));
	}
}