package crypto;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.security.spec.AlgorithmParameterSpec;
import java.text.DecimalFormat;
import java.text.NumberFormat;
import javax.crypto.Cipher;
import javax.crypto.SecretKey;
import javax.crypto.spec.IvParameterSpec;
import javax.crypto.spec.SecretKeySpec;

import security.abemodule.accesscontrol.AccessController;
import settings.HIPAA_ABE_Settings;
import sun.misc.BASE64Decoder;

public class DecryptionModule {
	public String userKeyPath;
	public String userKeyName;
	public String attributes;
	public String policies;
	public String abeEncryptedKeyPath;
	public String abeEncryptedKeyName;
	public String aesEncryptedFilePath;
	public String aesEncryptedFileName;
	public String decryptedFilePath;
	public String decryptedFileName;
	
	public boolean decrypt(){
		byte[] decryptedKey = null;
		boolean found = false;
		int count = 0;
		NumberFormat form = new DecimalFormat("000");
		File file = new File(abeEncryptedKeyPath+"/"+abeEncryptedKeyName+form.format(count)+".cpabe");
		while (file.exists()){
			AccessController accesscontroller = new AccessController(abeEncryptedKeyPath+"/"+abeEncryptedKeyName+form.format(count)+".cpabe",userKeyPath+"/"+userKeyName,HIPAA_ABE_Settings.locationofABETools, decryptedFilePath);
			accesscontroller.accessDocument();
			try {		 
		        String sCurrentLine;
		        BufferedReader br = 
		             new BufferedReader(new FileReader(decryptedFilePath +"/"+"a.out"));
		        
		        while ((sCurrentLine = br.readLine()) != null) {
			       if(sCurrentLine.contains("Plaintext") && sCurrentLine.contains("Key-")){
			    	   found = true;
			    	   //decryptedKey = sCurrentLine.substring(sCurrentLine.indexOf("-")+1);
			    	   String base64Key = sCurrentLine.substring(sCurrentLine.indexOf("-")+1);
			    	   decryptedKey = (new BASE64Decoder()).decodeBuffer(base64Key);
			    	   break;
			       }
			 }          
		    } catch (FileNotFoundException e) {
		      e.printStackTrace(); 
		    } catch (IOException e) {	 
		      e.printStackTrace();		 
		    }
		    if (found)
		    	break;
		    count++;
		    file = new File(abeEncryptedKeyPath+"/"+abeEncryptedKeyName+form.format(count)+".cpabe");
		}
		if(found){
			try{
				ABEMessage msg = new ABEMessage();
				SecretKey aesKey = new SecretKeySpec(decryptedKey, "AES");
				FileInputStream in = new FileInputStream(aesEncryptedFilePath+"/"+aesEncryptedFileName);
				ObjectInputStream oi = new ObjectInputStream(in);
				msg = (ABEMessage) oi.readObject();
				
				AlgorithmParameterSpec paramSpec = new IvParameterSpec(msg.IVbytes);
				Cipher dcipher = Cipher.getInstance("AES/CBC/PKCS5Padding");
				dcipher.init(Cipher.DECRYPT_MODE, aesKey, paramSpec);
				String plainText = new String(dcipher.doFinal(msg.messageBytes));
				System.out.println("Decrypted message: " + plainText);
				
				//output to file
				FileOutputStream out = new FileOutputStream(decryptedFilePath+"/"+decryptedFileName);
				out.write(plainText.getBytes());
				out.close();
			}
			catch(Exception e){
				e.printStackTrace();
			}		
		}
		return found;
	}
}
