package server.process;

import java.io.IOException;
import java.io.PrintWriter;
import java.util.Random;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import settings.HIPAA_ABE_Settings;

public class ProcessInput extends HttpServlet {	
	public static Boolean debug = false;
	private static final long serialVersionUID = 1L;
    
    public ProcessInput() {
        super();
    }
    
	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		try {
			processRequest(request, response);
		} catch(Exception e) {
			System.err.println("Failed request");
			e.printStackTrace();
		}
	}
    
	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		try {
			processRequest(request, response);
		} catch(Exception e) {
			System.err.println("Failed request");
			e.printStackTrace();
		}	
	}

	protected void processRequest(HttpServletRequest request, HttpServletResponse response) throws Exception {
		long startTime = System.currentTimeMillis();
		String reqid = request.getParameter("reqid");
		System.out.println("Accepted request from " + request.getRemoteAddr() + " reqid=" + reqid);

		response.setContentType("text/html");
		String workingPath = HIPAA_ABE_Settings.baseDir + "/" + "abe-" + Integer.toString(Math.abs(new Random().nextInt()));
		
		PrintWriter out = response.getWriter();
        String type = request.getParameter("type");
        
        if(type == null) {
        	System.err.println("Malformed request: " + request.toString());
        	return;
        }
        
        ABERequest req = new ABERequest( this, reqid );
        
        if (type.equals("encrypt")) {
        	req.processEncrypt(request, workingPath, out);
        } else if (type.equals("keygen")) {
          	req.processKeygen(request, workingPath, out);
        }
       	else if (type.equals("decrypt"))     {
       		req.processDecrypt(request, workingPath, out);
        } else if (type.equals( "status" ))  {
        	System.out.println("Status bar update reqid=" + reqid);
        	req = ABERequest.lookup( reqid );
        	//String status = req.getStatusString();
        	String status = req.getStatusVal();
        	out.println(status);
        	System.out.println("Status bar update result: " + status);
        } else if (type.equals( "statusAll" ))  {
        	String status = ABERequest.getStatusAllString();
        	out.println("statusText|" + status);
        	System.out.println(status);    	
        } else {
        	System.err.println("Unknown request: " + request.toString());
        }

        System.out.println("Request processed in " + (System.currentTimeMillis() - startTime) + " ms");
	}
}

